#ifndef ORIGINAL_SOURCE

/*
 * This is a quick and dirty replacement for some BSD specific functions.
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>

#include "bsdport.h"

u_int32_t
arc4random (void)
{
	static int fd = -1;
	u_int32_t res;

	if (fd == -1) {
		fd = open ("/dev/urandom", O_RDONLY);
		if (fd<0) {
			perror ("Opening /dev/urandom");
			exit(1);
		}
	}
	if (read (fd, &res, sizeof(res)) < sizeof(res)) {
		perror ("Reading /dev/urandom");
		exit(1);
	}
	return res;
}

int
strvis (char *dst, char *src, int flag)
{
	int i;

	for (i=0 ; src[i] ; i++) {
		if ( ((src[i]>32)&&(src[i]<127)) ||
		     (src[i]==32) || (src[i]==9) || (src[i]==10) ||
		     (src[i]==8) || (src[i]==7) || (src[i]==13) )
			dst[i] = src[i];
		else
			dst[i] = '?';
	}
	dst[i] = 0;
	return i; /* number of characters in dst */
}

#endif
